#------------------------------------------------------------------------------#
#
# This function takes parameter values as input and returns the state space 
# representation required for the 'fkf' package.
#
#------------------------------------------------------------------------------#



ssmodel<-function(para,l,model_type){
  
  # measurement equation
  ct<-as.vector(rep(0,l+1))
  if (!model_type ==1){ct[1] = para[16]}
  
  Zt <- cbind(rep(1,l+1),diag(l+1))
  if (model_type ==3){Zt[1,1]<- para[17]}
  
  GGt <- matrix(0,nrow = l+1,ncol = l+1)
  
  # state equation
  dt <- as.vector(rep(0,2+l)) 
  
  Tt <- matrix(0, nrow = 2+l,ncol = 2+l)
  Tt[1,1]<-para[1]
  
  R <- matrix(0,nrow = 5,ncol = 8)
    R[1,1] <-  para[2]
    R[1,2:4] <-  para[3:5] + para[6:8]
    R[2,1] <-  -para[2]
    R[2,2:4] <-  -para[6:8]
    R[2,5]   <-  para[9]
    R[2,6:8] <-  para[13:15]
    R[3,2:4] <- -para[3:5]
    R[3:5,6:8] <- diag(para[10:12])
    R[4,3]   <- -para[4]
    R[4,4]   <- -para[5]
    R[5,4]   <- -para[5]
  
    HHt <- R%*%t(R)
    
    SSlist <- list(ct = ct, Zt = Zt, GGt = GGt, dt = dt, Tt = Tt, HHt = HHt)
}
